# -*- coding: utf-8 -*-
#
# Copyright 2018 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

from __future__ import absolute_import

import pkg_resources

__version__ = pkg_resources.get_distribution(
    "google-cloud-bigquery-storage"
).version  # noqa

from google.cloud.bigquery_storage_v1beta1 import types
from google.cloud.bigquery_storage_v1beta1 import client
from google.cloud.bigquery_storage_v1beta1.gapic import enums


class BigQueryStorageClient(client.BigQueryStorageClient):
    __doc__ = client.BigQueryStorageClient.__doc__
    enums = enums


__all__ = (
    # google.cloud.bigquery_storage_v1beta1
    "__version__",
    "types",
    # google.cloud.bigquery_storage_v1beta1.client
    "BigQueryStorageClient",
    # google.cloud.bigquery_storage_v1beta1.gapic
    "enums",
)
